-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp - all rights reserved.
-- 
-- For more scripts and sample code, check out 
-- 	http://www.SQLSkills.com
-- For "More than Just Training," see the Industry Experts at 
-- 	http://www.SolidQualityLearning.com
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

SET STATISTICS IO ON
-- Turn Graphical Showplan ON (Ctrl+K)

USE Credit
go

-- First review the indexes on member
sp_helpindex member
go

-- Create an index for a common combination of selected data and
-- search arguments

UPDATE dbo.member
	SET FirstName = 'Kimberly'
	WHERE member_no IN (1234, 678, 9753)

CREATE INDEX MemberName ON Member(LastName, FirstName, MiddleInitial)

-- Write a query which you would not think could benefit from this index...
SELECT LastName, FirstName, MiddleInitial
FROM dbo.member
WHERE FirstName = 'Kimberly'

-- Since there are no useful indexes to "seek" for FirstName AND because
-- SQL Server knows that FirstName = 'Kimberly' is highly selective (how?)
-- then SQL Server can use the NC index to scan...

-- What if the index does not cover?

SELECT *
FROM dbo.member
WHERE FirstName = 'Kimberly'

-- Even with bookmark lookups and an index scan this beats a table scan...

SELECT *
FROM dbo.member WITH (index (0))
WHERE FirstName = 'Kimberly'
