-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp - all rights reserved.
-- 
-- For more scripts and sample code, check out 
-- 	http://www.SQLSkills.com
-- For "More than Just Training," see the Industry Experts at 
-- 	http://www.SolidQualityLearning.com
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

--How to test time!
        DECLARE @starttime    datetime,
                    @endtime        datetime
        SELECT @starttime = getdate()
        --run your query (or queries)
        SELECT @endtime = getdate()
        SELECT 'totaltime' = datediff(ms, @starttime, @endtime)
--NOTE - if the times are small this could be off by as much as 10 ms

USE northwind
go
SET STATISTICS IO ON
go
--Correlated Subquery
DECLARE @starttime    datetime,
            @endtime        datetime
SELECT @starttime = getdate()
SELECT c.companyname
FROM dbo.customers as c
WHERE EXISTS
	(SELECT  *
    	 FROM dbo.orders as o
	 WHERE c.customerid = o.customerid
               AND o.orderdate >'1/1/95')
SELECT @endtime = getdate()
SELECT 'TotalTime(C)' = datediff(ms, @starttime, @endtime)

-- Join
SELECT @starttime = getdate()
SELECT distinct c.companyname
FROM dbo.customers as c
    JOIN dbo.orders as o 
        ON c.customerid = o.customerid
WHERE o.orderdate >'1/1/95'
SELECT @endtime = getdate()
SELECT 'TotalTime(J)' = datediff(ms, @starttime, @endtime)

-- Nested Subquery
SELECT @starttime = getdate()
SELECT companyname
FROM dbo.customers
WHERE customerid IN
	(SELECT  customerid
    	 FROM dbo.orders
	 WHERE orderdate >'1/1/95')
SELECT @endtime = getdate()
SELECT 'TotalTime(N)' = datediff(ms, @starttime, @endtime)
